REM Center a left-aligned text block
REM CenterVerse.csc  August, 2000
REM Copyright (C) Tramontana, 2000. Public domain.

DIM LineCount AS LONG
DIM Width AS LONG
DIM LeftPos AS LONG
DIM MaxWidth AS LONG
DIM i AS LONG
DIM LeftWhenCentered AS LONG
DIM LeftWhenAligned AS LONG

' **************************************************************************************
' MAIN
' **************************************************************************************
ON ERROR GOTO ErrorHandler

WITHOBJECT "CorelVentura.Automation.8"
  IF .GetSelectionType () = 1 THEN
    .FormatObjectBegin 1
    MaxWidth = 0
    LeftWhenCentered = 0
    .TextStartOfPara FALSE
    .FormatParaAlignment 0
    .TextLineInfoGet LineCount, , , LeftWhenAligned
    .FormatParaAlignment 1
    FOR i = 1 TO LineCount
      .TextLineInfoGet , , , LeftPos, , Width
      IF Width > MaxWidth THEN
        MaxWidth = Width
        LeftWhenCentered = LeftPos
      END IF
      .TextEndOfLine FALSE
    NEXT i
    .FormatParaAlignment 0, , , LeftWhenCentered - LeftWhenAligned
    .FormatObjectEnd
  ELSE
    MESSAGE "A paragraph should be selected!"
  END IF
END WITHOBJECT
STOP

ErrorHandler:
IF ErrNum > 0 THEN
  SELECT CASE ErrNum
  CASE 800
    MESSAGE "FATAL ERROR" & CHR(13) & "Script will now exit."
    STOP
  CASE ELSE
    MESSAGE "ERROR: " & STR(ErrNum) & CHR(13) & "Script will now exit."
    STOP
  END SELECT
END IF
STOP

